diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 0b8c2b39e..630c8cbe9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -2,7 +2,7 @@ package net.minecraft.core.entity.player;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.BlockBed;
+import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.EntityItem;
@@ -578,7 +578,7 @@ public abstract class Player extends Mob
             {
                 return getDisplayName() + deathMsgColor + " got lost in the sauce.";
             }
-            if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id)
+            if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id())
             {
                 return getDisplayName() + deathMsgColor + " fell for the trap.";
             }
@@ -710,7 +710,7 @@ public abstract class Player extends Mob
         world.entityJoinedWorld(entityitem);
     }
 
-    public float getCurrentPlayerStrVsBlock(Block block)
+    public float getCurrentPlayerStrVsBlock(Block<?> block)
     {
         float f = inventory.getStrVsBlock(block);
         float defaultBreakSpeed = (inventory.getCurrentItem() != null && inventory.getCurrentItem().getItem() instanceof ItemToolSword) ? 1.51f : 1.01f;
@@ -726,7 +726,7 @@ public abstract class Player extends Mob
         return f;
     }
 
-    public boolean canHarvestBlock(Block block)
+    public boolean canHarvestBlock(Block<?> block)
     {
         if (block == null) return false;
         return inventory.canHarvestBlock(block);
@@ -938,9 +938,8 @@ public abstract class Player extends Mob
         {
             return;
         }
-        List<Entity> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
-        for (Entity entity : list) {
-            MobWolf wolf = (MobWolf) entity;
+        List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+        for (MobWolf wolf : list) {
             if (wolf.isWolfTamed() && wolf.getTarget() == null && uuid.equals(wolf.getWolfOwner()) && (!flag || !wolf.isWolfSitting())) {
                 wolf.setTarget(attacker);
             }
@@ -1164,7 +1163,7 @@ public abstract class Player extends Mob
         if(world.isBlockLoaded(x, y, z))
         {
             int meta = world.getBlockMetadata(x, y, z);
-            int dir = BlockBed.getDirection(meta);
+            int dir = BlockLogicBed.getDirection(meta);
             float xOff = 0.5F;
             float zOff = 0.5F;
             
@@ -1222,10 +1221,11 @@ public abstract class Player extends Mob
         setSize(0.6F, 1.8F);
         resetHeight();
         ChunkCoordinates chunkcoordinates = bedChunkCoordinates;
-        if(chunkcoordinates != null && world.getBlock(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z) instanceof BlockBed)
+        Block<?> b;
+        if(chunkcoordinates != null && (b = world.getBlock(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z)) != null && b.getLogic() instanceof BlockLogicBed)
         {
-            BlockBed.setBedOccupied(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, false);
-            ChunkCoordinates chunkcoordinates2 = BlockBed.getNearestEmptyChunkCoordinates(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, 0);
+            BlockLogicBed.setBedOccupied(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, false);
+            ChunkCoordinates chunkcoordinates2 = BlockLogicBed.getNearestEmptyChunkCoordinates(world, chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z, 0);
             if(chunkcoordinates2 == null)
             {
                 chunkcoordinates2 = new ChunkCoordinates(chunkcoordinates.x, chunkcoordinates.y + 1, chunkcoordinates.z);
@@ -1248,7 +1248,8 @@ public abstract class Player extends Mob
 
     private boolean isInBed()
     {
-        return world.getBlock(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z) instanceof BlockBed;
+        Block<?> b;
+        return (b = world.getBlock(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z)) != null && b.getLogic() instanceof BlockLogicBed;
     }
 
     public static ChunkCoordinates getValidBedSpawnCoordinates(World world, ChunkCoordinates coords)
@@ -1259,8 +1260,9 @@ public abstract class Player extends Mob
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z - 3 >> 4);
         chunkProvider.prepareChunk(coords.x - 3 >> 4, coords.z + 3 >> 4);
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z + 3 >> 4);
-        if (world.getBlock(coords.x, coords.y, coords.z) instanceof BlockBed) {
-            return BlockBed.getNearestEmptyChunkCoordinates(world, coords.x, coords.y, coords.z, 0);
+        Block<?> b;
+        if ((b = world.getBlock(coords.x, coords.y, coords.z)) != null && b.getLogic() instanceof BlockLogicBed) {
+            return BlockLogicBed.getNearestEmptyChunkCoordinates(world, coords.x, coords.y, coords.z, 0);
         } else {
             return null;
         }
@@ -1271,7 +1273,7 @@ public abstract class Player extends Mob
         if(bedChunkCoordinates != null)
         {
             int i = world.getBlockMetadata(bedChunkCoordinates.x, bedChunkCoordinates.y, bedChunkCoordinates.z);
-            int j = BlockBed.getDirection(i);
+            int j = BlockLogicBed.getDirection(i);
             switch(j)
             {
             case 0: // '\0'
@@ -1548,7 +1550,7 @@ public abstract class Player extends Mob
     }
 
     public void pickBlock(int x, int y, int z) {
-    	Block block = world.getBlock(x, y, z);
+        Block<?> block = world.getBlock(x, y, z);
     	int meta = world.getBlockMetadata(x, y, z);
     	
     	if(block == null) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index 02853f6af..9f68bc9d9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -115,7 +115,7 @@ public class ProjectileArrow extends Projectile
             yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
             xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
         }
-        Block block = world.getBlock(xTile, yTile, zTile);
+        Block<?> block = world.getBlock(xTile, yTile, zTile);
         if(block != null)
         {
             AABB aabb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 31e44a513..8c97a350c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -116,7 +116,7 @@ public class EntityBoat extends Entity
         int numParticles = random.nextInt(8) + 1;
         for (int q = 0; q < numParticles; q++)
         {
-            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id, 0, Side.BOTTOM));
+            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id(), 0, Side.BOTTOM));
         }
         if(world.isClientSide || removed)
         {
@@ -146,7 +146,7 @@ public class EntityBoat extends Entity
                 spawnAtLocation(Items.BOAT.id, 1, 0.0F);
             }else {
                 for (int j = 0; j < 3; j++) {
-                    spawnAtLocation(Blocks.PLANKS_OAK.id, 1, 0.0F);
+                    spawnAtLocation(Blocks.PLANKS_OAK.id(), 1, 0.0F);
                 }
 
                 for (int k = 0; k < 2; k++) {
@@ -350,7 +350,7 @@ public class EntityBoat extends Entity
             int blockX = MathHelper.floor(x + ((double)(i % 2) - 0.5D) * 0.8D);
             int blockY = MathHelper.floor(y);
             int blockZ = MathHelper.floor(z + ((double)(i / 2) - 0.5D) * 0.8D);
-            Block block = world.getBlock(blockX, blockY, blockZ);
+            Block<?> block = world.getBlock(blockX, blockY, blockZ);
             if(block != null && block.hasTag(BlockTags.BOAT_BREAKS))
             {
                 world.setBlockWithNotify(blockX, blockY, blockZ, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 61f9ef542..5fd66e042 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -3,7 +3,7 @@ package net.minecraft.core.entity.vehicle;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRail;
+import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.logic.RailDirection;
@@ -200,11 +200,11 @@ public class MinecartEntity extends Entity implements Container {
                         if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
                             spawnAtLocation(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, typeMeta & TYPE_MASK_COLOR), 0.0F);
                         } else {
-                            spawnAtLocation(Blocks.CHEST_PLANKS_OAK.id, 1, 0.0F);
+                            spawnAtLocation(Blocks.CHEST_PLANKS_OAK.id(), 1, 0.0F);
                         }
                         break;
                     case FURNACE_CART:
-                        spawnAtLocation(Blocks.FURNACE_STONE_IDLE.id, 1, 0.0F);
+                        spawnAtLocation(Blocks.FURNACE_STONE_IDLE.id(), 1, 0.0F);
                         break;
                 }
             }
@@ -287,20 +287,20 @@ public class MinecartEntity extends Entity implements Container {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
-        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockLogicRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
         final double maxSpeed = 0.4D;
         boolean didFurnacePush = false;
         final double d5 = 0.0078125D;
-        Block block = world.getBlock(blockX, blockY, blockZ);
-        if(block instanceof BlockRail) {
-            BlockRail rail = (BlockRail) block;
+        Block<?> block = world.getBlock(blockX, blockY, blockZ);
+        if(block != null && block.getLogic() instanceof BlockLogicRail) {
+            BlockLogicRail rail = (BlockLogicRail) block.getLogic();
             Vec3 vec3d = getPos(x, y, z);
             y = blockY;
             boolean onPoweredPoweredRail = false;
             boolean onUnpoweredPoweredRail = false;
-            if(rail == Blocks.RAIL_POWERED) {
+            if(block == Blocks.RAIL_POWERED) {
                 onPoweredPoweredRail = (world.getBlockMetadata(blockX, blockY, blockZ) & 0b1000) != 0;
                 onUnpoweredPoweredRail = !onPoweredPoweredRail;
             }
@@ -518,14 +518,14 @@ public class MinecartEntity extends Entity implements Container {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
-        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockLogicRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
 
-        Block block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block instanceof BlockRail)) { return null; }
+        Block<?> block = world.getBlock(blockX, blockY, blockZ);
+        if (!(block != null && block.getLogic() instanceof BlockLogicRail)) { return null; }
 
-        BlockRail rail = (BlockRail) block;
+        BlockLogicRail rail = (BlockLogicRail) block.getLogic();
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
         if(rail.getIsPowered()) {
             meta &= 0b111;
@@ -559,13 +559,13 @@ public class MinecartEntity extends Entity implements Container {
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
 
-        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockLogicRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
-        Block block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block instanceof BlockRail)) { return null; }
+        Block<?> block = world.getBlock(blockX, blockY, blockZ);
+        if (!(Block.hasLogicClass(block, BlockLogicRail.class))) { return null; }
 
-        BlockRail rail = (BlockRail) block;
+        BlockLogicRail rail = (BlockLogicRail) block.getLogic();
         RailDirection direction = rail.getRailDirection(world, blockX, blockY, blockZ);
 
         int[][] offsetMap = EXITS[direction.meta];
@@ -707,7 +707,7 @@ public class MinecartEntity extends Entity implements Container {
                     if (carriedBlock.entity instanceof TileEntityChest) {
                         TileEntityChest chest = (TileEntityChest) carriedBlock.entity;
                         this.type = CHEST_CART;
-                        if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id) {
+                        if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id()) {
                             this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST;
                         } else {
                             this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR;
@@ -736,7 +736,7 @@ public class MinecartEntity extends Entity implements Container {
                             this.setItem(i, null);
                         }
                         blockEntity.worldObj = null;
-                        Block block;
+                        Block<?> block;
                         if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
                             block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index ad227b48c..1f51d14a9 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -165,7 +165,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
     }
 
-    public float getStrVsBlock(ItemStack itemstack, Block block)
+    public float getStrVsBlock(ItemStack itemstack, Block<?> block)
     {
         return 1.0F;
     }
@@ -185,9 +185,9 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return hasSubtypes;
     }
 
-    protected Item setHasSubtypes(boolean flag)
+    protected Item setHasSubtypes(boolean hasSubtypes)
     {
-        hasSubtypes = flag;
+        this.hasSubtypes = hasSubtypes;
         return this;
     }
 
@@ -207,7 +207,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return maxDamage > 0 && !hasSubtypes;
     }
 
-    public boolean hitEntity(ItemStack itemstack, Mob entityliving, Mob entityliving1)
+    public boolean hitEntity(ItemStack itemstack, Mob target, Mob attacker)
     {
         return false;
     }
@@ -230,12 +230,12 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return 1;
     }
 
-    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
     {
         return false;
     }
 
-    public boolean useItemOnEntity(ItemStack itemstack, Mob entityliving, Player entityPlayer)
+    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player)
     {
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index ccad71853..3fb6abc01 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.BlockBed;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -23,7 +22,6 @@ public class ItemBed extends Item
     		blockY += side.getOffsetY();
     		blockZ += side.getOffsetZ();
     	}
-        BlockBed blockbed = (BlockBed) Blocks.BED;
         int i1 = entityplayer.getHorizontalPlacementDirection(null).getOpposite().getHorizontalIndex();
         byte byte0 = 0;
         byte byte1 = 0;
@@ -45,10 +43,10 @@ public class ItemBed extends Item
         }
         if(world.isAirBlock(blockX, blockY, blockZ) && world.isAirBlock(blockX + byte0, blockY, blockZ + byte1) && world.canPlaceOnSurfaceOfBlock(blockX, blockY - 1, blockZ) && world.canPlaceOnSurfaceOfBlock(blockX + byte0, blockY - 1, blockZ + byte1))
         {
-            if(world.canBlockBePlacedAt(blockbed.id, blockX, blockY, blockZ, false, side) && itemstack.consumeItem(entityplayer)) {
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockbed, EnumBlockSoundEffectType.PLACE);
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockbed.id, i1);
-                world.setBlockAndMetadataWithNotify(blockX + byte0, blockY, blockZ + byte1, blockbed.id, i1 + 8);
+            if(world.canBlockBePlacedAt(Blocks.BED.id(), blockX, blockY, blockZ, false, side) && itemstack.consumeItem(entityplayer)) {
+                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.BED.id(), i1);
+                world.setBlockAndMetadataWithNotify(blockX + byte0, blockY, blockZ + byte1, Blocks.BED.id(), i1 + 8);
                 return true;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index f3408371a..88d499739 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -51,7 +51,7 @@ public class ItemBoat extends Item
             int k = movingobjectposition.z;
             if(!world.isClientSide)
             {
-                if(world.getBlockId(i, j, k) == Blocks.LAYER_SNOW.id)
+                if(world.getBlockId(i, j, k) == Blocks.LAYER_SNOW.id())
                 {
                     j--;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 96034047b..7bc7d50d4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -12,30 +12,29 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class ItemBucket extends Item
 {
-	private final int idToPlace;
-    public ItemBucket(String name, String namespaceId, int id, Block blockToPlace)
+	private final @Nullable Block<?> blockToPlace;
+    public ItemBucket(String name, String namespaceId, int id, @Nullable Block<?> blockToPlace)
     {
         super(name, namespaceId, id);
         maxStackSize = 1;
-        if (blockToPlace == null)
-        {
-            this.idToPlace = -1;
-        }
-        else
-        {
-            this.idToPlace = blockToPlace.id;
-        }
+        this.blockToPlace = blockToPlace;
     }
 
     @Override
 	public ItemStack onUseItem(ItemStack stack, World world, Player player) {
+		if(blockToPlace == null) {
+			// Milk
+			return new ItemStack(Items.BUCKET);
+		}
+
 		double reachDistance = player.getGamemode().getBlockReachDistance();
-		HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, idToPlace == 0, false);
+		HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, false, false);
 		
 		if(rayTraceResult == null || rayTraceResult.hitType != HitResult.HitType.TILE) {
 			return stack;
@@ -49,12 +48,7 @@ public class ItemBucket extends Item
 			return stack;
 		}
 		
-		if(idToPlace < 0) {
-			// Milk
-			return new ItemStack(Items.BUCKET);
-		}
-		
-		Block block = world.getBlock(x, y, z);
+		Block<?> block = world.getBlock(x, y, z);
 		if(block != null && !block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
 			Side side = rayTraceResult.side;
 			x += side.getOffsetX();
@@ -67,21 +61,21 @@ public class ItemBucket extends Item
 		}
 		
 		if(world.isAirBlock(x, y, z) || !world.getBlockMaterial(x, y, z).isSolid()) {
-			if(world.dimension == Dimension.NETHER && idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
+			if(world.dimension == Dimension.NETHER && blockToPlace == Blocks.FLUID_WATER_FLOWING) {
 				world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
 				for (int l = 0; l < 8; l++) {
 					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
 				}
 			} else {
-				if(idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
+				if(blockToPlace == Blocks.FLUID_WATER_FLOWING) {
 					world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x + 0.5F, y + 0.5F, z + 0.5F, "liquid.splash", 0.5f, 1.0f);
 				}
 				player.swingItem();
-				Block block1 = world.getBlock(x, y, z);
+				Block<?> block1 = world.getBlock(x, y, z);
 				if(block1 != null) {
 					block1.dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
 				}
-				world.setBlockAndMetadataWithNotify(x, y, z, idToPlace, 0);
+				world.setBlockAndMetadataWithNotify(x, y, z, blockToPlace.id(), 0);
 			}
 			if(player.getGamemode().consumeBlocks()) {
 				return new ItemStack(Items.BUCKET);
@@ -93,16 +87,16 @@ public class ItemBucket extends Item
 
 	@Override
 	public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
-		if (idToPlace < 0) {
+		if (blockToPlace == null) {
 			itemStack.itemID = Items.BUCKET.id;
 			return;
 		}
 		int x = blockX + direction.getOffsetX();
 		int y = blockY + direction.getOffsetY();
 		int z = blockZ + direction.getOffsetZ();
-		Block b = world.getBlock(x, y, z);
+		Block<?> b = world.getBlock(x, y, z);
 		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b) || BlockTags.BROKEN_BY_FLUIDS.appliesTo(b)) {
-			world.setBlockWithNotify(x, y, z, idToPlace);
+			world.setBlockWithNotify(x, y, z, blockToPlace.id());
 			itemStack.itemID = Items.BUCKET.id;
 		}
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index 6573ae216..14ed270b6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
@@ -82,7 +81,7 @@ public class ItemBucketEmpty extends Item
         }
 
         AABB box = AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
-        List<Entity> entities = world.getEntitiesWithinAABB(MobCow.class, box);
+        List<MobCow> entities = world.getEntitiesWithinAABB(MobCow.class, box);
         if (!entities.isEmpty()) {
             itemStack.itemID = Items.BUCKET_MILK.id;
             return;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
index 0e9dc9935..b276c13d4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.BlockJukebox;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
@@ -28,10 +27,10 @@ public class ItemDiscMusic extends Item
     @Override
     public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
-        if(world.getBlockId(blockX, blockY, blockZ) == Blocks.JUKEBOX.id && world.getBlockMetadata(blockX, blockY, blockZ) == 0)
+        if(world.getBlockId(blockX, blockY, blockZ) == Blocks.JUKEBOX.id() && world.getBlockMetadata(blockX, blockY, blockZ) == 0)
         {
             if (!world.isClientSide) {
-                ((BlockJukebox) Blocks.JUKEBOX).playRecord(world, blockX, blockY, blockZ, id);
+                Blocks.JUKEBOX.getLogic().playRecord(world, blockX, blockY, blockZ, id);
                 world.playBlockEvent(null, LevelListener.EVENT_JUKEBOX_TOGGLE, blockX, blockY, blockZ, id);
                 itemstack.consumeItem(entityplayer);
             }
@@ -48,8 +47,8 @@ public class ItemDiscMusic extends Item
         int y = blockY + direction.getOffsetY();
         int z = blockZ + direction.getOffsetZ();
         int b = world.getBlockId(x, y, z);
-        if (b == Blocks.JUKEBOX.id && world.getBlockMetadata(x, y, z) == 0) {
-            ((BlockJukebox) Blocks.JUKEBOX).playRecord(world, x, y, z, id);
+        if (b == Blocks.JUKEBOX.id() && world.getBlockMetadata(x, y, z) == 0) {
+            Blocks.JUKEBOX.getLogic().playRecord(world, x, y, z, id);
             world.playBlockEvent(null, LevelListener.EVENT_JUKEBOX_TOGGLE, blockX, blockY, blockZ, id);
             itemStack.consumeItem(null);
         }
